;;;; mother modular generic compiler project
; (c)2002/GPL Oskar Schirmer <oskar@scara.com>
; see file COPYING for GPL license details

; ansi C language line break splicer
; according to Harbison and Steele, "C A Reference Manual", ISBN 0-13-110933-2
 
; usage:
;   splicelinebreak <withouttrigraphs.c >withoutlinestosplice.c

; purpose:
;   splice lines in c source, which end with backslash

(define delinebreak
  (lambda (input extra)
    (if (not (eof-object? input))
      (if (char=? input #\\)
        (let ((next (read-char)))
          (if (eqv? next #\newline)
            (delinebreak (read-char) (+ extra 1))
            (begin
              (write-char #\\)
              (delinebreak next extra))))
        (begin
          (write-char input)
          (if
            (and
              (> extra 0)
              (eqv? input #\newline))
            (delinebreak input (- extra 1))
            (delinebreak (read-char) extra)))))))
(delinebreak (read-char) 0)
