;;;; mother modular generic compiler project
; (c)2002/GPL Oskar Schirmer <oskar@scara.com>
; see file COPYING for GPL license details

; ansi C language trigraph resolver
; according to Harbison and Steele, "C A Reference Manual", ISBN 0-13-110933-2

; usage:
;   trigraphresolve <original.c >withouttrigraphs.c

; purpose:
;   resolves trigraphs in c source

(define detrigraph
  (lambda (input pendingq)
    (if (eof-object? input)
      (if (positive? pendingq)
        (begin
          (write-char #\?)
          (detrigraph input (- pendingq 1))))
      (if (char=? input #\?)
        (if (> pendingq 1)
          (begin
            (write-char #\?)
            (detrigraph (read-char) pendingq))
          (detrigraph (read-char) (+ pendingq 1)))
        (if (> pendingq 1)
          (let ((s (assv input
              '((#\( . #\[) (#\) . #\])
                (#\< . #\{) (#\> . #\})
                (#\/ . #\\) (#\! . #\|)
                (#\' . #\^) (#\- . #\~)
                (#\= . #\#)))))
            (if s
              (write-char (cdr s))
              (begin
                (write-char #\?)
                (write-char #\?)
                (write-char input)))
            (detrigraph (read-char) 0))
          (begin
            (if (positive? pendingq)
              (write-char #\?))
            (write-char input)
            (detrigraph (read-char) 0)))))))
(detrigraph (read-char) 0)
